CSL 5.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes
csl::SndFileInstrument Class Reference

Sound file player instrument. More...

`#include <SndFileInstrument.h>`

Inheritance diagram for csl::SndFileInstrument:

List of all members.

## Public Member Functions
| SndFileInstrument (string path, int start=-1, int stop=-1)
| SndFileInstrument (string folder, string path, int start=-1, int stop=-1)
| ~SndFileInstrument ()
void | setParameter (unsigned selector, int argc, void **argv, const char *types)
| Plug functions.
void | play ()
| play note
void | playOSC (int argc, void **argv, const char *types)
void | playNote (float ampl=1, float rate=1, float pos=0, int start=-1, int stop=-1, float attack=0.0, float decay=0.0)
void | playMIDI (int chan, int key, int vel)
| These are the UGens of the DSP graph (i.e., the sndfile player instrument)
UnitGenerator * | graph ()
| Accessors.
UGenMap * | genMap ()
| my UGen graph
UGenVector * | envelopes ()
| the map of ugens in the graph by name
const string | name ()
| the vector of envelopes to query or trigger
UnitGenerator * | genNamed (string name)
| answer my name answer the number of channels
AccessorVector | getAccessors ()
| Accessor management.
unsigned | numAccessors ()
| answer the accessor vector
virtual void | nextBuffer (Buffer &outputBuffer) throw (CException)
| set a named parameter
virtual void | nextBuffer (Buffer &outputBuffer, unsigned outBufNum) throw (CException)
| really compute the next buffer given an offset base channel; this is called by nextBuffer, possibly multiple times
virtual bool | isActive ()
| Envelope query and re-trigger.
virtual void | playNote (int argc, void **argv, const char *types)
| Play a note (subclasses refine)
virtual void | playMIDI (float dur, int chan, int key, int vel)
virtual void | release ()
unsigned | frameRate ()
void | setFrameRate (unsigned rate)
| get/set the receiver's frame rate
virtual unsigned | numChannels ()
void | setNumChannels (unsigned ch)
| get/set the receiver's number of outputs
BufferCopyPolicy | copyPolicy ()
void | setCopyPolicy (BufferCopyPolicy ch)
| get/set the receiver's buffer copy policy
virtual bool | isFixed ()
| query whether I'm fixed (StaticVariable overrides this)
void | addOutput (UnitGenerator *ugen)
| add to or return the UGen vector of outputs
void | removeOutput (UnitGenerator *ugen)
UGenVector | outputs ()
virtual unsigned | numOutputs ()
bool | checkFanOut (Buffer &outputBuffer) throw (CException)
| check for fan-out and copy previous buffer; return true if fanning out
void | handleFanOut (Buffer &outputBuffer) throw (CException)
virtual void | setValue (sample theValue)
| set/get the value (not allowed in the abstract, useful for static values)
virtual sample | value ()
virtual void | dump ()
| pretty-print the receiver
virtual void | trigger ()
void | attachObserver (Observer *)
| (possibly notify obersvers on my death)
void | detachObserver (Observer *)
void | changed (void *argument)
| this is what I send to myself to notify my observers; It's not overridden in general. It results in the observers receiving update() calls < override evaluate to filter updates to the observer map
virtual int | evaluate (void *argument)

## Public Attributes
LSoundFile | mPlayer
| sample player
AR | mEnvelope
| AR envelope.
Panner | mPanner
| stereo panner
StaticVariable | mRate
| plugs playback rate (ignored for now)
int | mStart
int | mStop
| start/stop sample indices

## Protected Member Functions
void | initialize (string path)
void | zeroBuffer (Buffer &outputBuffer, unsigned outBufNum)
| utility method to zero out an outputBuffer

## Protected Attributes
UnitGenerator * | mGraph
| Caches.
string | mName
| my name
UGenMap | mUGens
| the map of ugens in the graph by name
UGenVector | mEnvelopes
| the vector of envelopes to query or trigger
AccessorVector | mAccessors
| the accessor vector
unsigned | mFrameRate
| trigger ignored here
unsigned | mNumChannels
| my "expected" number of output channels
BufferCopyPolicy | mCopyPolicy
| the policy I use if asked for more or fewer channels
UGenVector | mOutputs
| the vector of my output UGens
unsigned | mNumOutputs
| the number of outputs
Buffer * | mOutputCache
| my past output ring buffer (only used in case of fan-out)
unsigned | mSequence
| the highest-seen buffer seq number

## Detailed Description

Sound file player instrument.

Definition at line 39 of file SndFileInstrument.h.

## Constructor & Destructor Documentation

SndFileInstrument::SndFileInstrument | ( | string | path,
|  | int | start = `-1`,
|  | int | stop = `-1`
| ) |  |

Definition at line 13 of file SndFileInstrument.cpp.

References initialize().

SndFileInstrument::SndFileInstrument | ( | string | folder,
|  | string | path,
|  | int | start = `-1`,
|  | int | stop = `-1`
| ) |  |

Definition at line 22 of file SndFileInstrument.cpp.

References initialize().

SndFileInstrument::~SndFileInstrument | ( |  | ) |

Definition at line 62 of file SndFileInstrument.cpp.

## Member Function Documentation

void SndFileInstrument::setParameter | ( | unsigned | selector,
|  | int | argc,
|  | void ** | argv,
|  | const char * | types
| ) |  |
| virtual

Plug functions.

Reimplemented from csl::Instrument.

Definition at line 66 of file SndFileInstrument.cpp.

References csl::Abst_SoundFile::durationInSecs(), csl::kLogError, csl::logMsg(), mEnvelope, mPanner, mPlayer, mRate, csl::LSoundFile::openForRead(), csl::Abst_SoundFile::path(), set_amplitude_f, set_attack_f, set_decay_f, set_file_f, set_position_f, set_rate_f, set_start_f, set_stop_f, csl::AR::setAttack(), csl::AR::setDuration(), csl::Abst_SoundFile::setPath(), csl::Panner::setPosition(), csl::AR::setRelease(), csl::Scalable::setScale(), csl::Abst_SoundFile::setStart(), csl::Abst_SoundFile::setStop(), csl::Abst_SoundFile::setToEnd(), and csl::StaticVariable::setValue().

void SndFileInstrument::play | ( |  | ) |
| virtual

play note

Reimplemented from csl::Instrument.

Reimplemented in csl::SampleBankInstrument.

Definition at line 199 of file SndFileInstrument.cpp.

References mEnvelope, mPlayer, csl::Envelope::trigger(), and csl::Abst_SoundFile::trigger().

Referenced by testSndFileInstrument().

void SndFileInstrument::playOSC | ( | int | argc,
|  | void ** | argv,
|  | const char * | types
| ) |  |
| virtual

Reimplemented from csl::Instrument.

Reimplemented in csl::SampleBankInstrument.

Definition at line 109 of file SndFileInstrument.cpp.

References csl::UnitGenerator::frameRate(), csl::kLogError, csl::logMsg(), mEnvelope, mPanner, mPlayer, mRate, csl::AR::setAttack(), csl::AR::setDuration(), csl::Panner::setPosition(), csl::AR::setRelease(), csl::Scalable::setScale(), csl::Abst_SoundFile::setStart(), csl::Abst_SoundFile::setStartRatio(), csl::Abst_SoundFile::setStop(), csl::Abst_SoundFile::setStopRatio(), csl::StaticVariable::setValue(), csl::Abst_SoundFile::startFrame(), csl::Abst_SoundFile::stopFrame(), csl::Envelope::trigger(), and csl::Abst_SoundFile::trigger().

void SndFileInstrument::playNote | ( | float | ampl = `1`,
|  | float | rate = `1`,
|  | float | pos = `0`,
|  | int | start = `-1`,
|  | int | stop = `-1`,
|  | float | attack = `0.0`,
|  | float | decay = `0.0`
| ) |  |

Reimplemented in csl::SampleBankInstrument.

Definition at line 207 of file SndFileInstrument.cpp.

References csl::UnitGenerator::frameRate(), mEnvelope, mPanner, mPlayer, mRate, csl::AR::setAttack(), csl::AR::setDuration(), csl::Panner::setPosition(), csl::AR::setRelease(), csl::Scalable::setScale(), csl::Abst_SoundFile::setStart(), csl::Abst_SoundFile::setStop(), csl::StaticVariable::setValue(), csl::Envelope::trigger(), and csl::Abst_SoundFile::trigger().

void csl::SndFileInstrument::playMIDI | ( | int | chan,
|  | int | key,
|  | int | vel
| ) |  |

These are the UGens of the DSP graph (i.e., the sndfile player instrument)

void SndFileInstrument::initialize | ( | string | path | ) |
| protected

Definition at line 31 of file SndFileInstrument.cpp.

References CSL_FLOAT_TYPE, CSL_INT_TYPE, CSL_STRING_TYPE, csl::kLogError, csl::logMsg(), csl::Instrument::mAccessors, mEnvelope, csl::Instrument::mGraph, csl::CException::mMessage, csl::Instrument::mName, csl::UnitGenerator::mNumChannels, mPanner, mPlayer, mRate, csl::Instrument::mUGens, csl::LSoundFile::openForRead(), set_amplitude_f, set_attack_f, set_decay_f, set_file_f, set_position_f, set_rate_f, set_start_f, set_stop_f, and csl::Scalable::setScale().

Referenced by SndFileInstrument().

UnitGenerator* csl::Instrument::graph | ( |  | ) |
| inline inherited

Accessors.

Definition at line 63 of file Instrument.h.

References csl::Instrument::mGraph.

UGenMap* csl::Instrument::genMap | ( |  | ) |
| inline inherited

my UGen graph

Definition at line 64 of file Instrument.h.

References csl::Instrument::mUGens.

Referenced by csl::Instrument::Instrument().

UGenVector* csl::Instrument::envelopes | ( |  | ) |
| inline inherited

the map of ugens in the graph by name

Definition at line 65 of file Instrument.h.

References csl::Instrument::mEnvelopes.

Referenced by csl::Instrument::Instrument().

const string csl::Instrument::name | ( |  | ) |
| inline inherited

the vector of envelopes to query or trigger

Definition at line 67 of file Instrument.h.

References csl::Instrument::mName.

Referenced by setupOSCInstrLibrary().

UnitGenerator * Instrument::genNamed | ( | string | name | ) |
| inherited

answer my name answer the number of channels

get a UGen from the graph

Definition at line 47 of file Instrument.cpp.

References csl::Instrument::mUGens.

AccessorVector csl::Instrument::getAccessors | ( |  | ) |
| inline inherited

Accessor management.

Definition at line 72 of file Instrument.h.

References csl::Instrument::mAccessors.

Referenced by csl::Instrument::Instrument(), and setupOSCInstrLibrary().

unsigned csl::Instrument::numAccessors | ( |  | ) |
| inline inherited

answer the accessor vector

Definition at line 73 of file Instrument.h.

References csl::Instrument::mAccessors.

Referenced by setupOSCInstrLibrary().

void Instrument::nextBuffer | ( | Buffer & | outputBuffer | ) | throw (CException)
| virtual inherited

set a named parameter

get a UGen from the graph

Sample creation

Reimplemented from csl::UnitGenerator.

Definition at line 41 of file Instrument.cpp.

void UnitGenerator::nextBuffer | ( | Buffer & | outputBuffer,
|  | unsigned | outBufNum
| ) |  | throw (CException)
| virtual inherited

really compute the next buffer given an offset base channel; this is called by nextBuffer, possibly multiple times

Reimplemented in csl::Joiner, csl::Splitter, csl::FanOut, SAFliter, csl::RandEnvelope, csl::Moog, csl::AmbisonicDecoder, csl::Impulse, csl::Square, csl::AmbisonicEncoder, csl::Sawtooth, csl::FSine, csl::MulOp, csl::Envelope, csl::Sine, csl::DynamicVariable, csl::Filter, csl::AmbisonicRotator, csl::CompOrCacheOscillator, csl::BufferStream, csl::AddOp, csl::FIR, csl::WavetableOscillator, csl::PinkNoise, csl::VBAP, csl::RtpReceiver, csl::SineAsScaled, csl::SpatialSource, csl::LineSegment, csl::StaticVariable, csl::AmbisonicMixer, csl::WhiteNoise, csl::SineAsPhased, csl::SpatialPanner, csl::Window, csl::RingBufferTap, csl::BinaryOp, csl::Freeverb, csl::KarplusString, csl::RtpSender, csl::Clipper, csl::Lorenz, csl::SimpleSine, csl::DistanceSimulator, and csl::WaveShaper.

Definition at line 605 of file CSL_Core.cpp.

bool Instrument::isActive | ( |  | ) |
| virtual inherited

Envelope query and re-trigger.

Reimplemented from csl::UnitGenerator.

Definition at line 57 of file Instrument.cpp.

References FALSE, csl::UnitGenerator::isActive(), csl::Instrument::mEnvelopes, csl::Instrument::mGraph, and TRUE.

Referenced by csl::MIDIPlayer::start().

virtual void csl::Instrument::playNote | ( | int | argc,
|  | void ** | argv,
|  | const char * | types
| ) |  |
| inline virtual inherited

Play a note (subclasses refine)

Definition at line 82 of file Instrument.h.

virtual void csl::Instrument::playMIDI | ( | float | dur,
|  | int | chan,
|  | int | key,
|  | int | vel
| ) |  |
| inline virtual inherited

Reimplemented in csl::VAdditiveInstrument, csl::FancyFMInstrument, csl::FMInstrument, csl::AdditiveInstrument, and csl::WhiteNoiseInstrument.

Definition at line 83 of file Instrument.h.

Referenced by csl::MIDIPlayer::start().

void Instrument::release | ( |  | ) |
| virtual inherited

Definition at line 76 of file Instrument.cpp.

References csl::Instrument::mEnvelopes, and csl::UnitGenerator::trigger().

unsigned csl::UnitGenerator::frameRate | ( |  | ) |
| inline inherited

Definition at line 225 of file CSL_Core.h.

References csl::UnitGenerator::mFrameRate.

Referenced by csl::CASoundFile::dump(), csl::Abst_SoundFile::dump(), csl::SoundCue::dump(), csl::Filter::init(), playNote(), and playOSC().

void csl::UnitGenerator::setFrameRate | ( | unsigned | rate | ) |
| inline inherited

get/set the receiver's frame rate

Definition at line 226 of file CSL_Core.h.

References csl::UnitGenerator::mFrameRate.

Referenced by m3_header().

virtual unsigned csl::UnitGenerator::numChannels | ( |  | ) |
| inline virtual inherited

Reimplemented in csl::Splitter, and csl::Stereoverb.

Definition at line 228 of file CSL_Core.h.

References csl::UnitGenerator::mNumChannels.

Referenced by csl::AmbisonicMixer::addInput(), csl::BlockResizer::BlockResizer(), csl::Port::checkBuffer(), csl::Effect::Effect(), csl::AmbisonicRotator::initialize(), csl::AmbisonicDecoder::initialize(), m3_output(), csl::Mixer::nextBuffer(), and csl::SpatialSource::SpatialSource().

void csl::UnitGenerator::setNumChannels | ( | unsigned | ch | ) |
| inline inherited

get/set the receiver's number of outputs

Definition at line 229 of file CSL_Core.h.

References csl::UnitGenerator::mNumChannels.

Referenced by csl::BinauralPanner::BinauralPanner(), m3_output(), csl::Spatializer::Spatializer(), csl::VBAP::speakerLayoutChanged(), and csl::VBAP::VBAP().

BufferCopyPolicy csl::UnitGenerator::copyPolicy | ( |  | ) |
| inline inherited

Definition at line 231 of file CSL_Core.h.

References csl::UnitGenerator::mCopyPolicy.

void csl::UnitGenerator::setCopyPolicy | ( | BufferCopyPolicy | ch | ) |
| inline inherited

get/set the receiver's buffer copy policy

Definition at line 232 of file CSL_Core.h.

References csl::UnitGenerator::mCopyPolicy.

Referenced by csl::AmbisonicPanner::AmbisonicPanner(), csl::BinauralPanner::BinauralPanner(), csl::AmbisonicUnitGenerator::initOrder(), csl::Noise::Noise(), csl::PinkNoise::PinkNoise(), csl::Spatializer::Spatializer(), and csl::VBAP::VBAP().

virtual bool csl::UnitGenerator::isFixed | ( |  | ) |
| inline virtual inherited

query whether I'm fixed (StaticVariable overrides this)

Reimplemented in csl::StaticVariable, and csl::BinaryOp.

Definition at line 247 of file CSL_Core.h.

void UnitGenerator::addOutput | ( | UnitGenerator * | ugen | ) |
| inherited

add to or return the UGen vector of outputs

Definition at line 520 of file CSL_Core.cpp.

References csl::Buffer::allocateBuffers(), csl::CGestalt::maxBufferFrames(), csl::UnitGenerator::mNumOutputs, csl::UnitGenerator::mOutputCache, and csl::UnitGenerator::mOutputs.

Referenced by csl::Mixer::addInput(), csl::Controllable::addInput(), csl::AmbisonicRotator::initialize(), csl::AmbisonicDecoder::initialize(), csl::AmbisonicEncoder::setInput(), and csl::IO::setRoot().

void UnitGenerator::removeOutput | ( | UnitGenerator * | ugen | ) |
| inherited

Definition at line 530 of file CSL_Core.cpp.

References csl::UnitGenerator::mNumOutputs, and csl::UnitGenerator::mOutputs.

Referenced by csl::IO::clearRoot(), csl::AmbisonicEncoder::setInput(), csl::AmbisonicDecoder::~AmbisonicDecoder(), and csl::AmbisonicRotator::~AmbisonicRotator().

UGenVector csl::UnitGenerator::outputs | ( |  | ) |
| inline inherited

Definition at line 253 of file CSL_Core.h.

References csl::UnitGenerator::mOutputs.

virtual unsigned csl::UnitGenerator::numOutputs | ( |  | ) |
| inline virtual inherited

Definition at line 254 of file CSL_Core.h.

References csl::UnitGenerator::mNumOutputs.

bool UnitGenerator::checkFanOut | ( | Buffer & | outputBuffer | ) | throw (CException)
| inherited

check for fan-out and copy previous buffer; return true if fanning out

Definition at line 549 of file CSL_Core.cpp.

void UnitGenerator::handleFanOut | ( | Buffer & | outputBuffer | ) | throw (CException)
| inherited

Definition at line 563 of file CSL_Core.cpp.

References csl_max.

virtual void csl::UnitGenerator::setValue | ( | sample | theValue | ) |
| inline virtual inherited

set/get the value (not allowed in the abstract, useful for static values)

Reimplemented in csl::DynamicVariable, and csl::StaticVariable.

Definition at line 260 of file CSL_Core.h.

virtual sample csl::UnitGenerator::value | ( |  | ) |
| inline virtual inherited

Reimplemented in csl::StaticVariable.

Definition at line 261 of file CSL_Core.h.

void UnitGenerator::dump | ( | void |  | ) |
| virtual inherited

pretty-print the receiver

Reimplemented in csl::RandEnvelope, csl::SumOfSines, csl::SoundCue, csl::Abst_SoundFile, csl::Envelope, csl::Filter, csl::VBAP, csl::SineAsScaled, csl::LineSegment, csl::SpatialSource, csl::SineAsPhased, csl::Mixer, csl::Window, csl::KarplusString, csl::Oscillator, csl::AmbisonicPanner, csl::BinaryOp, csl::Lorenz, csl::Clipper, csl::CASoundFile, and csl::Noise.

Definition at line 543 of file CSL_Core.cpp.

References csl::logMsg(), and csl::UnitGenerator::mOutputs.

Referenced by csl::Port::dump(), dumpTest(), and testSimpleSines().

virtual void csl::UnitGenerator::trigger | ( | void |  | ) |
| inline virtual inherited

Reimplemented in csl::Joiner, csl::Effect, csl::RandEnvelope, csl::SoundCue, csl::Abst_SoundFile, csl::Envelope, csl::LineSegment, and csl::KarplusString.

Definition at line 264 of file CSL_Core.h.

Referenced by csl::Instrument::play(), csl::Instrument::release(), and csl::Port::trigger().

void UnitGenerator::zeroBuffer | ( | Buffer & | outputBuffer,
|  | unsigned | outBufNum
| ) |  |
| protected inherited

utility method to zero out an outputBuffer

Definition at line 513 of file CSL_Core.cpp.

References csl::Buffer::mMonoBufferByteSize, and csl::Buffer::monoBuffer().

void Model::attachObserver | ( | Observer * | o | ) |
| inherited

(possibly notify obersvers on my death)

register/remove observers

Definition at line 491 of file CGestalt.cpp.

References csl::logMsg(), csl::Observer::mKey, and csl::Observer::mPeriod.

Referenced by csl::SpatialPanner::setSpeakerLayout().

void Model::detachObserver | ( | Observer * | o | ) |
| inherited

Definition at line 507 of file CGestalt.cpp.

References csl::logMsg().

Referenced by csl::SpatialPanner::setSpeakerLayout(), and csl::SpatialPanner::~SpatialPanner().

void Model::changed | ( | void * | argument | ) |
| inherited

this is what I send to myself to notify my observers; It's not overridden in general. It results in the observers receiving update() calls < override evaluate to filter updates to the observer map

Definition at line 529 of file CGestalt.cpp.

References csl::logMsg().

Referenced by csl::SpeakerLayout::addSpeaker(), csl::MIDIIn::handleIncomingMidiMessage(), and csl::SpeakerLayout::setDefaultSpeakerLayout().

virtual int csl::Model::evaluate | ( | void * | argument | ) |
| inline virtual inherited

Reimplemented in csl::MIDIIn.

Definition at line 259 of file CGestalt.h.

## Member Data Documentation

LSoundFile csl::SndFileInstrument::mPlayer

sample player

Definition at line 55 of file SndFileInstrument.h.

Referenced by initialize(), play(), playNote(), playOSC(), and setParameter().

AR csl::SndFileInstrument::mEnvelope

AR envelope.

Definition at line 56 of file SndFileInstrument.h.

Referenced by initialize(), play(), playNote(), playOSC(), and setParameter().

Panner csl::SndFileInstrument::mPanner

stereo panner

Definition at line 57 of file SndFileInstrument.h.

Referenced by initialize(), playNote(), playOSC(), and setParameter().

StaticVariable csl::SndFileInstrument::mRate

plugs playback rate (ignored for now)

Definition at line 58 of file SndFileInstrument.h.

Referenced by initialize(), playNote(), playOSC(), and setParameter().

int csl::SndFileInstrument::mStart

Definition at line 59 of file SndFileInstrument.h.

int csl::SndFileInstrument::mStop

start/stop sample indices

Definition at line 59 of file SndFileInstrument.h.

UnitGenerator* csl::Instrument::mGraph
| protected inherited

Caches.

my UGen graph

Definition at line 87 of file Instrument.h.

Referenced by csl::FMInstrument::FMInstrument(), csl::Instrument::graph(), csl::AdditiveInstrument::init(), initialize(), and csl::Instrument::isActive().

string csl::Instrument::mName
| protected inherited

my name

Definition at line 88 of file Instrument.h.

Referenced by csl::FancyFMInstrument::FancyFMInstrument(), csl::FMInstrument::FMInstrument(), csl::AdditiveInstrument::init(), initialize(), and csl::Instrument::name().

UGenMap csl::Instrument::mUGens
| protected inherited

the map of ugens in the graph by name

Definition at line 89 of file Instrument.h.

Referenced by csl::FancyFMInstrument::FancyFMInstrument(), csl::FMInstrument::FMInstrument(), csl::Instrument::genMap(), csl::Instrument::genNamed(), csl::AdditiveInstrument::init(), initialize(), and csl::Instrument::Instrument().

UGenVector csl::Instrument::mEnvelopes
| protected inherited

the vector of envelopes to query or trigger

Definition at line 90 of file Instrument.h.

Referenced by csl::Instrument::envelopes(), csl::FancyFMInstrument::FancyFMInstrument(), csl::FMInstrument::FMInstrument(), csl::AdditiveInstrument::init(), csl::Instrument::Instrument(), csl::Instrument::isActive(), csl::Instrument::play(), and csl::Instrument::release().

AccessorVector csl::Instrument::mAccessors
| protected inherited

the accessor vector

Definition at line 91 of file Instrument.h.

Referenced by csl::FMInstrument::FMInstrument(), csl::Instrument::getAccessors(), csl::AdditiveInstrument::init(), initialize(), csl::Instrument::Instrument(), and csl::Instrument::numAccessors().

unsigned csl::UnitGenerator::mFrameRate
| protected inherited

trigger ignored here

the frame rate – initialized to be the default by the constructor

Definition at line 264 of file CSL_Core.h.

Referenced by csl::Abst_SoundFile::convertRate(), csl::RtpSender::createRtpSession(), csl::RtpReceiver::createRtpSession(), csl::Lorenz::dump(), csl::Abst_SoundFile::durationInSecs(), csl::UnitGenerator::frameRate(), csl::Filter::init(), csl::CASoundFile::initFromSndfile(), csl::JSoundFile::initFromSndfile(), csl::LSoundFile::initFromSndfile(), csl::RandEnvelope::nextSegment(), csl::SquareBL::nextWaveInto(), csl::SumOfSines::nextWaveInto(), csl::CASoundFile::openForRead(), csl::MP3File::openForRead(), csl::DelayLine::setDelayTime(), csl::UnitGenerator::setFrameRate(), csl::Abst_SoundFile::setStartSec(), csl::Abst_SoundFile::setStopSec(), csl::Butter::setupCoeffs(), csl::Formant::setupCoeffs(), csl::Notch::setupCoeffs(), csl::Moog::setupCoeffs(), and csl::DecodedFile::writeBuffer().

unsigned csl::UnitGenerator::mNumChannels
| protected inherited

my "expected" number of output channels

Definition at line 268 of file CSL_Core.h.

Referenced by csl::AmbisonicMixer::addInput(), csl::Mixer::allocateOpBuffer(), csl::AmbisonicDecoder::asProjection(), csl::AmbisonicDecoder::asPseudoInverse(), csl::BlockResizer::BlockResizer(), csl::Abst_SoundFile::channels(), csl::Abst_SoundFile::checkBuffer(), csl::DecodedFile::checkBufferStack(), csl::FMInstrument::FMInstrument(), csl::GrainPlayer::GrainPlayer(), csl::AdditiveInstrument::init(), csl::JSoundFile::initFromSndfile(), csl::LSoundFile::initFromSndfile(), csl::AmbisonicMixer::initialize(), initialize(), csl::AmbisonicRotator::initialize(), csl::AmbisonicEncoder::initialize(), csl::AmbisonicDecoder::initialize(), csl::AmbisonicUnitGenerator::initOrder(), csl::RemoteStream::initPacket(), csl::Joiner::isActive(), csl::AmbisonicDecoder::makeInPhase(), csl::AmbisonicDecoder::makeMaxRE(), csl::DecodedFile::mergeBuffers(), csl::Abst_SoundFile::mergeToMono(), csl::Mixer::Mixer(), csl::UnitGenerator::numChannels(), csl::CASoundFile::openForRead(), csl::MP3File::openForRead(), csl::Panner::Panner(), csl::CASoundFile::readBufferFromFile(), csl::JSoundFile::readBufferFromFile(), csl::LSoundFile::readBufferFromFile(), csl::RemoteStream::RemoteStream(), csl::UnitGenerator::setNumChannels(), csl::WavetableOscillator::setWaveform(), csl::Joiner::trigger(), csl::DecodedFile::writeBuffer(), and csl::AmbisonicRotator::~AmbisonicRotator().

BufferCopyPolicy csl::UnitGenerator::mCopyPolicy
| protected inherited

the policy I use if asked for more or fewer channels

Definition at line 269 of file CSL_Core.h.

Referenced by csl::UnitGenerator::copyPolicy(), and csl::UnitGenerator::setCopyPolicy().

UGenVector csl::UnitGenerator::mOutputs
| protected inherited

the vector of my output UGens

Definition at line 270 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput(), csl::UnitGenerator::dump(), csl::UnitGenerator::outputs(), and csl::UnitGenerator::removeOutput().

unsigned csl::UnitGenerator::mNumOutputs
| protected inherited

the number of outputs

Definition at line 271 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput(), csl::UnitGenerator::numOutputs(), and csl::UnitGenerator::removeOutput().

Buffer* csl::UnitGenerator::mOutputCache
| protected inherited

my past output ring buffer (only used in case of fan-out)

Definition at line 272 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput().

unsigned csl::UnitGenerator::mSequence
| protected inherited

the highest-seen buffer seq number

Definition at line 273 of file CSL_Core.h.

The documentation for this class was generated from the following files:

- CSL/Instruments/SndFileInstrument.h
- CSL/Instruments/SndFileInstrument.cpp